#include "stdafx.h"
#include <hash_set>

const std::string BasicSource::generateDirectiveName = "#generate";


class CDefine{
	stdext::hash_set<std::string> names;
public:
//	void Free();
	void Init( bool isDebug, bool isDll, bool isUnicode, int majorVer );

	bool add(char const *name);
	bool undef(char const *name);
	bool check(char const *name);
	void preprocessor_ifdef(char *buffer,bool isNot);
	void DirectiveIfdef(char *buffer);
};
CDefine objDefine;


//////////////////////////////////////
// #require̊Ǘ
//////////////////////////////////////
namespace
{
class CRequireFiles{
	stdext::hash_set<std::string> filepaths;
public:
	void clear(){
		filepaths.clear();
	}
	//ɑ݂̂ǉ悤ƂfalseԂiIsIncludedƋtȂƂɒӁj
	bool TryAdd( const std::string &includeFilePath ){
		char tempPath[MAX_PATH];
		DWORD len = GetShortPathName(includeFilePath.c_str(), tempPath, MAX_PATH);
		if (len >= MAX_PATH){
			return false;
		}
		for( DWORD i = 0; i < len; ++i ){
			char c = toupper(tempPath[i]);
			if (c == '/'){
				tempPath[i] = '\\';
			}
			else{
				tempPath[i] = c;
			}
		}
		return filepaths.insert( tempPath ).second;
	}
};
CRequireFiles requireFiles;
} //namespace

//////////////////////////////////////
// #defineԂNX
//////////////////////////////////////

void CDefine::Init( bool isDebug, bool isDll, bool isUnicode, int majorVer )
{
	names.clear();

	if( isDebug )
	{
		add("_DEBUG");
	}

#ifdef _AMD64_
	add("_WIN64");
#endif

	if( isDll )
	{
		add("_DLL");
	}

	if( isUnicode )
	{
		add( "UNICODE" );
	}

	char temporary[255];
	sprintf(temporary,"_AB_VER%d",majorVer);
	add(temporary);
}
bool CDefine::add(char const *name)
{
	return names.insert(name).second;
}
bool CDefine::undef(char const *name){
	return names.erase(name) > 0;
}
bool CDefine::check(char const *name){
	return names.find(name) != names.end();
}

int Search_endif(char const *buffer,int i, int *pLine = 0){
	for(;;i++){
		if(buffer[i]=='\0') break;

		if( buffer[i] == '\n' ){
			if( pLine ){
				(*pLine)++;
			}
		}

		if(buffer[i-1]=='\n'){
			if(_memicmp(buffer+i,"#ifdef",6)==0||_memicmp(buffer+i,"#ifndef",7)==0){
				i=Search_endif(buffer,i+6, pLine);
				if(buffer[i]=='\0') break;
				continue;
			}
			else if(_memicmp(buffer+i,"#endif",6)==0){
				break;
			}
		}
	}
	return i;
}

void CDefine::preprocessor_ifdef(char *buffer,bool isNot){
	int i,i2,i3;
	char temporary[VN_SIZE];

	if(isNot) i=strlen("#ifndef");
	else i=strlen("#ifdef");
	while(buffer[i]==' '||buffer[i]=='\t') i++;

	for(i2=0;;i++,i2++){
		if(buffer[i]=='\n'||buffer[i]=='\0'){
			temporary[i2]=0;
			break;
		}
		temporary[i2]=buffer[i];
	}

	int sw=0;
	if(check(temporary)) sw=1;

	if(isNot){
		//#ifndef̂Ƃi΂ɂj
		if(sw) sw=0;
		else sw=1;
	}

	//#ifdef̍s
	memset(buffer,' ',static_cast<size_t>(i));

	BOOL bElse=0;
	if(sw){
		//TRUÊƂ

		//#elseA#endifT
		for(;;i++){
			if(buffer[i]=='\0') break;

			if(i==0||buffer[i-1]=='\n'){
				if(memicmp(buffer+i,"#ifdef",6)==0||memicmp(buffer+i,"#ifndef",7)==0){
					i=Search_endif(buffer,i+6);
					if(buffer[i]=='\0') break;
					continue;
				}
				else if(memicmp(buffer+i,"#else",5)==0){
					i2=5;
					bElse=1;
					break;
				}
				else if(memicmp(buffer+i,"#endif",6)==0){
					i2=6;
					bElse=0;
					break;
				}
			}
		}

		//s
		Text::SlideString(buffer+i+i2,-i2);

		if(bElse){
			//#elseꍇ͂̋Ԃ

			for(i2=i,i3=0;;i2++){
				if(buffer[i2]=='\0') break;

				if(buffer[i2]=='\n') i3++;

				if(i2==0||buffer[i2-1]=='\n'){
					if(memicmp(buffer+i2,"#ifdef",6)==0||memicmp(buffer+i2,"#ifndef",7)==0){
						i2=Search_endif(buffer,i2+6, &i3 );
						if(buffer[i2]=='\0') break;
						continue;
					}
					if(memicmp(buffer+i2,"#endif",6)==0){
						i2+=6;
						break;
					}
				}
			}

			//\[XR[hԂAsR[h}
			Text::SlideString(buffer+i2,i-i2+i3);
			memset(buffer+i,'\n',i3);
		}
	}
	else{
		//FALSÊƂ

		//#elseA#endifT
		for(i2=i,i3=0;;i2++){
			if(buffer[i2]=='\0') break;

			if(buffer[i2]=='\n') i3++;

			if(i2==0||buffer[i2-1]=='\n'){
				if(memicmp(buffer+i2,"#ifdef",6)==0||memicmp(buffer+i2,"#ifndef",7)==0){
					i2=Search_endif(buffer,i2+6, &i3 );
					if(buffer[i2]=='\0') break;
					continue;
				}
				else if(memicmp(buffer+i2,"#else",5)==0){
					i2+=5;
					bElse=1;
					break;
				}
				else if(memicmp(buffer+i2,"#endif",6)==0){
					i2+=6;
					bElse=0;
					break;
				}
			}
		}

		//\[XR[hԂAsR[h}
		Text::SlideString(buffer+i2,i-i2+i3);
		memset(buffer+i,'\n',i3);

		if(bElse){
			//#endifT
			for(;;i++){
				if(buffer[i]=='\0') break;

				if(i==0||buffer[i-1]=='\n'){
					if(memicmp(buffer+i,"#ifdef",6)==0||memicmp(buffer+i,"#ifndef",7)==0){
						i=Search_endif(buffer,i+6);
						if(buffer[i]=='\0') break;
						continue;
					}
					else if(memicmp(buffer+i,"#endif",6)==0){
						i2=6;
						bElse=0;
						break;
					}
				}
			}

			//s
			Text::SlideString(buffer+i+i2,-i2);
		}
	}
}


void CDefine::DirectiveIfdef(char *buffer){
	int i,i2,i3,sw;
	char temporary[VN_SIZE];

	for(i=0;;i++){
		if(buffer[i]=='\0') break;

		if(i==0||(i>=1&&buffer[i-1]=='\n')){
			sw=0;
			if(memicmp(buffer+i,"#define",7)==0){
				i2=i+7;
				while(buffer[i2]==' '||buffer[i2]=='\t') i2++;

				for(i3=0;;i2++,i3++){
					if(buffer[i2]=='\n'||buffer[i2]=='\0'){
						temporary[i3]=0;
						break;
					}
					temporary[i3]=buffer[i2];
				}
				add(temporary);
				//fBNeBu
				memset(buffer+i,' ',static_cast<size_t>(i2-i));
				i=i2;
			}
			if(memicmp(buffer+i,"#undef",6)==0){
				i2=i+6;
				while(buffer[i2]==' '||buffer[i2]=='\t') i2++;

				for(i3=0;;i2++,i3++){
					if(buffer[i2]=='\n'||buffer[i2]=='\0'){
						temporary[i3]=0;
						break;
					}
					temporary[i3]=buffer[i2];
				}
				undef(temporary);
				//fBNeBu
				memset(buffer+i,' ',static_cast<size_t>(i2-i));
				i=i2;
			}
			else if(memicmp(buffer+i,"#ifdef",6)==0){
				preprocessor_ifdef(buffer+i,false);
				continue;
			}
			else if(memicmp(buffer+i,"#ifndef",7)==0){
				preprocessor_ifdef(buffer+i,true);
				continue;
			}
			else continue;
		}
	}
}




bool Text::ReadFile( const std::string &filePath ){
	//t@CI[v
	HANDLE hFile=CreateFile(filePath.c_str(),GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(hFile==INVALID_HANDLE_VALUE){
		return false;
	}

	length = GetFileSize( hFile, NULL );

	buffer = (char *)realloc( buffer, length + 1 );

	//ǂݍ
	DWORD dwAccBytes;
	::ReadFile(hFile,buffer,length,&dwAccBytes,0);
	buffer[dwAccBytes]=0;

	//t@CN[Y
	CloseHandle(hFile);

	return true;
}

//sR[hCRLFLFɕϊ
int ChangeReturnCodeImpl(char *buffer)
{
	int i;
	for(i=0;buffer[i]!='\0';i++){
		if(buffer[i]=='\r'&&buffer[i+1]=='\n'){
			buffer[i]=' ';
		}
	}
	return i;
}

void BasicSource::ChangeReturnLineChar(){
	int i;

	bool isMustChange = false;
	for( i=0; ; i++ ){
		if( buffer[i] == '\0' ){
			break;
		}
		if( buffer[i]=='\n' )
		{
			if( i>0 )
			{
				if( buffer[i-1] == '\r' )
				{
					isMustChange = true;
				}
			}
		}
	}

	if( !isMustChange )
	{
		// sR[h̕ϊ͕KvȂ
		return;
	}

#ifdef _DEBUG
	//sR[h̐`FbN
	for( i=0; ; i++ ){
		if( buffer[i] == '\0' ){
			break;
		}
		if( buffer[i]!='\r' && buffer[i+1]=='\n'
			||  buffer[i]=='\r' && buffer[i+1]!='\n' ){
				char temporary[255];
				strncpy( temporary, buffer + i-100, 130 );
				temporary[130] = 0;
				for(int i2=0; ;i2++){
					if(temporary[i2]=='\r') temporary[i2]='A';
					if(temporary[i2]=='\n') temporary[i2]='B';
					if(temporary[i2]=='\0') break;
				}

				extern HWND hOwnerEditor;
				MessageBox( hOwnerEditor, temporary, "sR[h̐`FbN", MB_OK | MB_ICONEXCLAMATION );
		}
	}
#endif

	ChangeReturnCodeImpl(buffer);

	length = i;
}

void BasicSource::RemoveComments(){
	int i,i2,i3,IsStr;
	char *temporary=static_cast<char *>(malloc(strlen(buffer)+1));
	for(i=0,i2=0,i3=0,IsStr=0;;i++,i2++){
		if(buffer[i]=='\"') IsStr^=1;
		if(buffer[i]=='\n'||buffer[i]=='\0'){
			i2--;
			while(temporary[i2]==' '||temporary[i2]=='\t') i2--;
			i2++;

			if(i3){
				//sɓn钍ߕ̒ɉs݂Ƃ
				memset(temporary+i2,'\n',i3);
				i2+=i3;
				i3=0;
			}
		}
		if(buffer[i]=='\''&&IsStr==0){
			//ߕ
			i2--;
			while(temporary[i2]==' '||temporary[i2]=='\t') i2--;
			i2++;
			while(buffer[i]!='\n'&&buffer[i]!='\0') i++;
		}
		if(buffer[i]=='/'&&buffer[i+1]=='*'&&IsStr==0){
			//ߕisj
			i+=2;
			i3=0;
			while(!(buffer[i]=='*'&&buffer[i+1]=='/')){
				if(buffer[i]=='\n') i3++;
				if(buffer[i]=='\0') break;
				i++;
			}
			if(buffer[i]){
				i+=2;
			}
			i--;
			i2--;
			continue;
		}
		temporary[i2]=buffer[i];
		if(buffer[i]=='\0') break;
	}
	std::swap(buffer,temporary);
	free(temporary);
}

bool BasicSource::ReadFile_InIncludeDirective( const std::string &filePath ){
	if( !Text::ReadFile( filePath ) ){
		return false;
	}

	// sR[hCRLFLFɕϊ
	ChangeReturnLineChar();

	// Rg폜
	RemoveComments();

	// #ifdeffBNeBu
	objDefine.DirectiveIfdef( buffer );

	// A_[o[ɂs𐳋K\ɖ߂
	RemoveReturnLineUnderbar();

	// _~[sZbg
	Realloc( length + 2 );
	Text::SlideString( buffer, 2 );
	buffer[0] = '\n';
	buffer[1] = '\n';

	return true;
}

void BasicSource::DirectiveIncludeOrRequire( const std::string &mainSourceFilePath, const std::string &includeDirPath )
{
	int i,i2,i3,sw1,LineNum,FileLayer[255],layer,LastFileByte[255];
	char temporary[MAX_PATH],temp2[MAX_PATH+255],*LayerDir[255];

	layer=0;
	FileLayer[layer]=0;
	LastFileByte[layer]=GetLength();
	LineNum=0;

	if( includedFilesRelation.GetLineCounts() != 0 )
	{
		Jenga::Throw( "CN[ht@C\̏ls" );
	}

	// C\[XR[h
	FileLayer[layer] = includedFilesRelation.AddFile( mainSourceFilePath );

	//QƃfBNg
	std::string mainSourceFileDir = Jenga::Common::Path::ExtractDirPath( mainSourceFilePath );
	LayerDir[0]=(char *)malloc(mainSourceFileDir.size()+1);
	strcpy(LayerDir[0],mainSourceFileDir.c_str());

	for(i=0;;i++){
		if(buffer[i]=='\0'){
			break;
		}
		if(buffer[i]=='\n'){
			includedFilesRelation.AddLine( FileLayer[layer] );
		}
		if(i>LastFileByte[layer]){
			free(LayerDir[layer]);
			LayerDir[layer]=0;
			layer--;
		}
		if((buffer[i-1]=='\n'||i==0)&&buffer[i]=='#'){
			bool isRequire = false;

			int includeDirectiveLength;

			char findStr[1024];
			if(memcmp( buffer + i + 1, "include", 7 ) == 0
				|| memcmp( buffer + i + 1, "require", 7 ) == 0)
			{
				//#requirȅꍇ
				if( buffer[i + 1] == 'r' ) isRequire = true;

				i2=i+8;
				while(buffer[i2]==' '||buffer[i2]=='\t') i2++;

				if(buffer[i2]=='\"') sw1=0;
				else if(buffer[i2]=='<') sw1=1;
				i2++;

				for(i3=0;;i2++,i3++){
					if((buffer[i2]=='\"'&&sw1==0)||(buffer[i2]=='>'&&sw1==1)||buffer[i2]=='\n'||buffer[i2]=='\0'){
						temporary[i3]=0;
						break;
					}
					temporary[i3]=buffer[i2];
				}
				while(buffer[i2]!='\n'&&buffer[i2]!='\0') i2++;

				includeDirectiveLength = i2 - i;

				if(sw1){
					sprintf(temp2,"%s\\%s", includeDirPath.c_str(), temporary );
					strcpy(findStr,temp2);
				}
				else{
					Jenga::Common::Directory dir( LayerDir[layer] );
					strcpy( findStr, dir.GetFullPath( temporary ).c_str() );
				}
			}
			else if(memcmp(buffer+i+1,"prompt",6)==0){
				includeDirectiveLength = 7;
				sprintf(findStr,"%s\\basic\\prompt.sbp", includeDirPath.c_str() );
			}
			else if(memcmp(buffer+i+1,"N88BASIC",8)==0){
				includeDirectiveLength = 9;
				sprintf(findStr,"%s\\basic\\prompt.sbp", includeDirPath.c_str() );
			}
			else if(memcmp(buffer+i+1,"console",7)==0){
				//TuVXe ^CvCUIɕύX
				extern unsigned short TypeOfSubSystem;
				TypeOfSubSystem=IMAGE_SUBSYSTEM_WINDOWS_CUI;

				includeDirectiveLength = 8;
				sprintf(findStr,"%s\\basic\\dos_console.sbp", includeDirPath.c_str() );
			}
			else continue;

			// CN[ht@C񋓁iChJ[hwzj
			Jenga::Common::Strings resultOfFullPath;
			Jenga::Common::FileSystem::SearchFiles( resultOfFullPath, findStr );

			if( resultOfFullPath.empty() )
			{
				this->cannotIncludePath = findStr;
				this->cannotIncludeSourcePos = i;
				includedFilesRelation.AddLine( FileLayer[layer] );
				break;
			}

			for( int j=static_cast<int>(resultOfFullPath.size()-1); j>=0; j-- )
			{
				const std::string &sourceFilePath = resultOfFullPath[j];

				const int headIndex = i;

				if( headIndex == 0 && Jenga::Common::Path( sourceFilePath ).GetFileName() == "basic" )
				{
					// basic.sbpCN[h͉Ȃ
					// ChJ[hŕt@Cw肵ꍇAQڈȏ̃t@C̏ꍇ
				}
				else
				{
					//fBNeBu邽߁AsĂ܂̂hibasic.sbpj
					Text::SlideString( buffer + headIndex + includeDirectiveLength, 1 );
					buffer[headIndex+includeDirectiveLength]='\n';
					for(i3=0;i3<=layer;i3++) LastFileByte[i3]++;
				}

				layer++;
				FileLayer[layer] = includedFilesRelation.AddFile( sourceFilePath );

				//#requirȅꍇł́Aɓǂݍ܂Ăt@C͓ǂݍ܂Ȃ悤ɂ
				BasicSource source;

				if( !requireFiles.TryAdd( sourceFilePath ) && isRequire ){
					//ɓǂݍ܂ĂƂ͋f[^
					source.SetBuffer( "" );
				}
				else{
					//CN[ht@Cǂݍ
					if( !source.ReadFile_InIncludeDirective( sourceFilePath ) )
					{
						_ASSERTE( false );
					}
				}

				Realloc( strlen(buffer) + source.GetLength() );
				Text::SlideString(
					buffer + headIndex + includeDirectiveLength,
					source.GetLength() - includeDirectiveLength
				);
				memcpy(
					buffer + headIndex,
					source.GetBuffer(),
					source.GetLength()
				);

				//VQƃfBNgZbg
				char temp4[MAX_PATH];
				_splitpath(sourceFilePath.c_str(),temp2,temp4,0,0);
				strcat(temp2,temp4);
				LayerDir[layer]=(char *)malloc(strlen(temp2)+1);
				strcpy(LayerDir[layer],temp2);

				//t@C͈͂XCh
				LastFileByte[layer] = headIndex + source.GetLength() - 1;
				for(i3=0;i3<layer;i3++)
				{
					LastFileByte[i3] += source.GetLength() - includeDirectiveLength;
				}

				includeDirectiveLength = 0;
			}
			i--;
		}
	}

	free(LayerDir[0]);

	length = strlen(buffer);
}

int KillReturnCode_InParameter(char *buffer,int *pRnum,char cBeginPare,char cEndPare){
	int i,i2,i3,IsStr;

	//JbR'('̉s
	while(buffer[0]=='\n'){
		buffer[0]=' ';
		(*pRnum)++;
	}

	for(i=0,IsStr=0;;i++){
		if(IsDBCSLeadByte(buffer[i])&&buffer[i+1]){
			i++;
			continue;
		}

		if(buffer[i]=='\"') IsStr^=1;

		if(buffer[i]=='\0') break;	//G[
		if(buffer[i]=='\n'){
			i2=0;
			i3=0;
			while(buffer[i+i2]=='\n'){
				i2++;
				i3++;
				while(buffer[i+i2]==' '||buffer[i+i2]=='\t') i2++;
			}
			while(buffer[i+i2]==' '||buffer[i+i2]=='\t') i2++;

			if(buffer[i+i2]==cEndPare){
				Text::SlideString(buffer+i+i2,-i2);
				(*pRnum)+=i3;
				break;
			}

			//G[
			break;
		}

		if(buffer[i]=='('&&IsStr==0){
			i++;
			i2=KillReturnCode_InParameter(buffer+i,pRnum,'(',')');
			i+=i2;
			if(buffer[i]!=')') break;
			continue;
		}
		if(buffer[i]=='['&&IsStr==0){
			i++;
			i2=KillReturnCode_InParameter(buffer+i,pRnum,'[',']');
			i+=i2;
			if(buffer[i]!=']') break;
			continue;
		}
		if(buffer[i]==cEndPare&&IsStr==0) break;

		if(buffer[i]==','&&buffer[i+1]=='\n'&&IsStr==0){
			i++;
			while(buffer[i]=='\n'){
				Text::SlideString(buffer+i+1,-1);
				(*pRnum)++;
			}
			i--;
		}
	}
	return i;
}
void BasicSource::RemoveReturnLineUnderbar(){
	int i,i2;

	//A_[o[ɂs
	for(i=0;;i++){
		i2=0;
		while(buffer[i]=='_'&&buffer[i+1]=='\n'){
			i2++;
			Text::SlideString(buffer+i+2,-2);
			while(buffer[i]=='\n'){
				Text::SlideString(buffer+i+1,-1);
				i2++;
			}
			for(;;i++){
				if(buffer[i]=='_'&&buffer[i+1]=='\n') break;
				if(buffer[i]=='\n'||buffer[i]=='\0'){
					Text::SlideString(buffer+i,i2);
					memset(buffer+i,'\n',i2);
					break;
				}
			}
		}
		if(buffer[i]=='\0') break;
	}

	//JbRp[^̉s
	int IsStr,rnum;
	for(i=0,IsStr=0,rnum=0;;i++){
		if(IsDBCSLeadByte(buffer[i])&&buffer[i+1]){
			i++;
			continue;
		}
		if(buffer[i]=='\0') break;
		if(buffer[i]=='\n'){
			if(rnum){
				Text::SlideString(buffer+i+1,rnum);
				memset(buffer+i+1,'\n',rnum);
				rnum=0;
			}
		}
		if(buffer[i]=='\"') IsStr^=1;
		if(buffer[i]=='('&&IsStr==0){
			i++;
			i2=KillReturnCode_InParameter(buffer+i,&rnum,'(',')');
			i+=i2;
			if(buffer[i]!=')') break;
		}
		if(buffer[i]=='['&&IsStr==0){
			i++;
			i2=KillReturnCode_InParameter(buffer+i,&rnum,'[',']');
			i+=i2;
			if(buffer[i]!=']') break;
		}
	}

	length = strlen(buffer);
}

void BasicSource::Initialize( const std::string &source )
{
	Clear();
	Add( source );

	// sR[hCRLFLFɕϊ
	ChangeReturnLineChar();

	// Rg폜
	RemoveComments();

	//ŏIsɂ͕܂܂Ȃ悤ɂ
	if( strlen(buffer)>0 && buffer[strlen(buffer)-1] != '\n' )
	{
		Realloc( length + 1 );
		strcat( buffer, "\n" );
	}

	// A_[o[ɂs𐳋K\ɖ߂
	RemoveReturnLineUnderbar();
}

// w肵CfbNXsڂ擾
bool BasicSource::GetLineFromIndex( int index, int &result ) const
{
	result = 0;
	for( int i=2; i<index; i++ )
	{
		if( this->buffer[i] == '\n' )
		{
			result ++;
		}
		if( this->buffer[i] == '\0' )
		{
			return false;
		}
	}
	return true;
}

void BasicSource::SetBuffer( const char *buffer ){
	this->buffer = (char *)calloc( strlen(buffer) + 1, 1 );
	strcpy( this->buffer, buffer );
	length = strlen(buffer);

	// _~[sZbg
	Realloc( length + 2 );
	Text::SlideString( this->buffer, 2 );
	this->buffer[0] = '\n';
	this->buffer[1] = '\n';
}

bool BasicSource::ReadFile( const std::string &filePath, bool isDebug, bool isDll, bool isUnicode, int majorVer, const std::string &mainSourceFilePath, const std::string &includeDirPath )
{
	if( !Text::ReadFile( filePath ) ){
		return false;
	}

	// sR[hCRLFLFɕϊ
	ChangeReturnLineChar();

	// #define#require
	// TODO: o[Wԍ̎ʎqdefine
	objDefine.Init( isDebug, isDll, isUnicode, majorVer );
	requireFiles.clear();

	// Rg폜
	RemoveComments();

	// #ifdeffBNeBu
	objDefine.DirectiveIfdef( buffer );

	//ŏIsɂ͕܂܂Ȃ悤ɂ
	Realloc( length + 1 );
	strcat( buffer, "\n" );

	// #include / #require fBNeBu
	DirectiveIncludeOrRequire( mainSourceFilePath, includeDirPath );

	// A_[o[ɂs𐳋K\ɖ߂
	RemoveReturnLineUnderbar();

	// _~[sZbg
	Realloc( length + 2 );
	Text::SlideString( buffer, 2 );
	buffer[0] = '\n';
	buffer[1] = '\n';

	extern char *basbuf;
	basbuf = GetBuffer();

	return true;
}

void BasicSource::Addition( const char *buffer ){
	Realloc( length + strlen(buffer) );
	strcat( this->buffer, buffer );
}

bool BasicSource::GetLineInfo( int sourceCodePos, int &line, std::string &filePath ) const
{
	const char *buffer = this->GetBuffer();
	if( this->GetLength() < sourceCodePos )
	{
		char temp[256];
		strncpy( temp, buffer, 100 );
		strcat( temp, "..." );
		MyAssertMsg( false, ( (std::string)"L\[XR[h" + Jenga::Common::ToString( sourceCodePos ) + "oCgځi݂ȂӏjQƂ悤ƂB\n\n" + temp ).c_str() );
		return false;
	}

	int i = sourceCodePos;
	int i2,i3,i4,i5;
	if(buffer[i]=='\n') i--;
	bool result = this->GetLineFromIndex( i, i2 );
	MyAssert( result );

	if( includedFilesRelation.GetLineCounts() <= i2 )
	{
		MyAssertMsg( false, "BasicSource::GetLineInfo\bhŕsȍs̏擾悤Ƃ" );

		//t@CEsԍłȂꍇ
		line = -1;
		filePath = "";
		return false;
	}

	i4=0;
	while( includedFilesRelation.GetFileNumber( i2 ) != includedFilesRelation.GetFileNumber( i4 ) )
	{
		i4++;
	}
	for(i3=0,i5=0;i5<i4;i3++){
		if(buffer[i3]=='\n') i5++;
		if(buffer[i3]=='\0')
		{
			MyAssert( false );
			return false;
		}
	}
	for(i5=0;i4<i2;i3++){
		if(buffer[i3]=='\n'){
			i4++;
			i5++;
			if( includedFilesRelation.GetFileNumber( i2 ) < includedFilesRelation.GetFileNumber( i4 ) )
			{
				for( ;includedFilesRelation.GetFileNumber( i2 ) != includedFilesRelation.GetFileNumber( i4 ); i3++ ){
					if(buffer[i3]=='\n') i4++;
				}
			}
		}
		if(buffer[i3]=='\0')
		{
			MyAssert( false );
			return false;
		}
	}

	//sԍZbg
	line = i5;

	//t@CZbg
	filePath = includedFilesRelation.GetFilePath( i2 );

	return true;
}

int SourceCodePosition::GetRelationalObjectModuleIndex() const
{
	if( this->IsNothing() )
	{
		_ASSERTE( false );
		throw;
	}

	return relationalObjectModuleIndex;
}
bool SourceCodePosition::IsNothing() const
{
	if( this->relationalObjectModuleIndex == -1 && this->pos == -1 )
	{
		return true;
	}

	if( this->relationalObjectModuleIndex == -1 || this->pos == -1 )
	{
		_ASSERTE( false );
		throw;
	}

	return false;
}
